/*    ___  _                           
 *   / _ \| |  __ _  _   _   ___  _ __ 
 *  / /_)/| | / _` || | | | / _ \| '__|
 * / ___/ | || (_| || |_| ||  __/| |   
 * \/     |_| \__,_| \__, | \___||_|   
 *                   |___/             
 */


#ifndef USE_AUTOPILOT
void backward();
void forward();
void shiftLeft();
void shiftRight();
#endif // USE_AUTOPILOT

void turnLeft();
void turnRight();




void player () {
    // switch (get()) {
    switch (key1) {
    case 8:  // left 
        turnLeft();
        break;
    case 9:  // right 
        turnRight();
        break;
#ifndef USE_AUTOPILOT
    case 10:  // down
        backward(); break;
    case 11:  // up
        forward(); break;
    // case 80:  // P        HEP !! DONT TOUCH THAT !!!
    //     glCamPosZ += 1; break;
    // case 59:  // ;       FORGET ABOUT IT !!
    //     glCamPosZ -= 1; break;
    // case 65:  // A
    //     glCamRotX -= 2; break;
    case 90:  // Z
        shiftLeft(); break;
    case 88:  // X
        shiftRight(); break;
#endif // USE_AUTOPILOT
    case 81:  // Q
        engRunning = 0; 
        break;
    default:
        break;
    }

}

#ifdef USE_GLORIC
#ifdef USE_RAYCASTING
void gl2rayCam(){
rayCamPosX = glCamPosX;
rayCamPosY = glCamPosY;
rayCamRotZ = glCamRotZ;
}
#endif
#endif



#ifndef __GNUC__

#endif
/*                          
 *   /\/\    ___  __   __  ___ 
 *  /    \  / _ \ \ \ / / / _ \
 * / /\/\ \| (_) | \ V / |  __/
 * \/    \/ \___/   \_/   \___|
 *                            
 */
// Collision Detection 
unsigned char isAllowedPosition(signed char X, signed char Y, signed char Z) {
    // if ((Y >= 56) && (Y <= 58) && ( X >=5 ) && ( X <= 76)) {
    //     return 0;
    // } else if ((Y >= 4)  && (Y <= 6)  && ( X >=5 ) && ( X <= 76)) {
    //     return 0;
    // } else if ((X >= 75) && (X <= 76) && (Y >= 5) && (Y <= 57)) {
    //     return 0;
    // } else if ((Y >= 18) && (Y <= 28) && (((X>=12) && (X<= 26)) || ((X>=54) && (X<= 66))) ){
    //     return 0;
    // }
    return 1;
}

#ifndef USE_AUTOPILOT

void forward() {
    signed int X, Y;
#ifdef USE_GLORIC
    X = glCamPosX; Y = glCamPosY;
    if (-112 >= glCamRotZ) {
        glCamPosX--;
    } else if ((-112 < glCamRotZ) && (-80 >= glCamRotZ)) {
        glCamPosX--; glCamPosY--;
    } else if ((-80 < glCamRotZ) && (-48 >= glCamRotZ)) {
        glCamPosY--;
    } else if ((-48 < glCamRotZ) && (-16 >= glCamRotZ)) {
        glCamPosX++; glCamPosY--;
    } else if ((-16 < glCamRotZ) && (16 >= glCamRotZ)) {
        glCamPosX++;
    } else if ((16 < glCamRotZ) && (48 >= glCamRotZ)) {
        glCamPosX++; glCamPosY++;
    } else if ((48 < glCamRotZ) && (80 >= glCamRotZ)) {
        glCamPosY++;
    } else if ((80 < glCamRotZ) && (112 >= glCamRotZ)) {
        glCamPosX--; glCamPosY++;
    } else {
        glCamPosX--;
    }
    if (!isAllowedPosition(glCamPosX, glCamPosY, 0)) {
        glCamPosX = X; glCamPosY = Y;
    }

#ifdef USE_RAYCASTING
    gl2rayCam();
#endif
#endif
}
void backward() {
    signed int X, Y;
#ifdef USE_GLORIC
    X = glCamPosX; Y = glCamPosY;
    if (-112 >= glCamRotZ) {
        glCamPosX++;
    } else if ((-112 < glCamRotZ) && (-80 >= glCamRotZ)) {
        glCamPosX++; glCamPosY++;
    } else if ((-80 < glCamRotZ) && (-48 >= glCamRotZ)) {
        glCamPosY++;
    } else if ((-48 < glCamRotZ) && (-16 >= glCamRotZ)) {
        glCamPosX--; glCamPosY++;
    } else if ((-16 < glCamRotZ) && (16 >= glCamRotZ)) {
        glCamPosX--;
    } else if ((16 < glCamRotZ) && (48 >= glCamRotZ)) {
        glCamPosX--; glCamPosY--;
    } else if ((48 < glCamRotZ) && (80 >= glCamRotZ)) {
        glCamPosY--;
    } else if ((80 < glCamRotZ) && (112 >= glCamRotZ)) {
        glCamPosX++; glCamPosY--;
    } else {
        glCamPosX++;
    }
    if (!isAllowedPosition(glCamPosX, glCamPosY, 0)) {
        glCamPosX = X; glCamPosY = Y;
    }
#ifdef USE_RAYCASTING
    gl2rayCam();
#endif
#endif
}
void shiftLeft() {
    signed int X, Y;
#ifdef USE_GLORIC
    X = glCamPosX; Y = glCamPosY;
    if (-112 >= glCamRotZ) {
        glCamPosY--;
    } else if ((-112 < glCamRotZ) && (-80 >= glCamRotZ)) {
        glCamPosX++; glCamPosY--;
    } else if ((-80 < glCamRotZ) && (-48 >= glCamRotZ)) {
        glCamPosX--;
    } else if ((-48 < glCamRotZ) && (-16 >= glCamRotZ)) {
        glCamPosX++; glCamPosY++;
    } else if ((-16 < glCamRotZ) && (16 >= glCamRotZ)) {
        glCamPosY++;
    } else if ((16 < glCamRotZ) && (48 >= glCamRotZ)) {
        glCamPosX--; glCamPosY++;
    } else if ((48 < glCamRotZ) && (80 >= glCamRotZ)) {
        glCamPosX--;
    } else if ((80 < glCamRotZ) && (112 >= glCamRotZ)) {
        glCamPosX--; glCamPosY--;
    } else {
        glCamPosY--;
    }
    if (!isAllowedPosition(glCamPosX, glCamPosY, 0)) {
        glCamPosX = X; glCamPosY = Y;
    }
#ifdef USE_RAYCASTING
    gl2rayCam();
#endif
#endif
}
void shiftRight() {
    signed int X, Y;
#ifdef USE_GLORIC
    X = glCamPosX;
    Y = glCamPosY;
    if (-112 >= glCamRotZ) {
        glCamPosY++;
    } else if ((-112 < glCamRotZ) && (-80 >= glCamRotZ)) {
        glCamPosX--; glCamPosY++;
    } else if ((-80 < glCamRotZ) && (-48 >= glCamRotZ)) {
        glCamPosX++;
    } else if ((-48 < glCamRotZ) && (-16 >= glCamRotZ)) {
        glCamPosX--; glCamPosY--;
    } else if ((-16 < glCamRotZ) && (16 >= glCamRotZ)) {
        glCamPosY--;
    } else if ((16 < glCamRotZ) && (48 >= glCamRotZ)) {
        glCamPosX++; glCamPosY--;
    } else if ((48 < glCamRotZ) && (80 >= glCamRotZ)) {
        glCamPosX++;
    } else if ((80 < glCamRotZ) && (112 >= glCamRotZ)) {
        glCamPosX++; glCamPosY++;
    } else {
        glCamPosX++;
    }
    if (!isAllowedPosition(glCamPosX, glCamPosY, 0)) {
        glCamPosX = X; glCamPosY = Y;
    }
#ifdef USE_RAYCASTING
    gl2rayCam();
#endif
#endif
}
#endif // USE_AUTOPILOT


void turnLeft(){
#ifdef USE_GLORIC
#ifdef USE_RAYCASTING
    glCamRotZ += ROT_ANGLE_STEP;
    RayLeftAlpha            = glCamRotZ + FOV_HALF_ANGLE;
    RayRightAlpha           = glCamRotZ - FOV_HALF_ANGLE;    
    
    // gl2rayCam();
    rayCamRotZ = glCamRotZ;

#endif
#endif
}
void turnRight(){
#ifdef USE_GLORIC
#ifdef USE_RAYCASTING
    glCamRotZ -= ROT_ANGLE_STEP; 
    RayLeftAlpha            = glCamRotZ + FOV_HALF_ANGLE;
    RayRightAlpha           = glCamRotZ - FOV_HALF_ANGLE;
    
    // gl2rayCam();
    rayCamRotZ = glCamRotZ;

#endif
#endif
}
