
#define USE_ASM_SHAPELOADER_DATA
#define USE_ASM_SHAPELOADER

#ifdef  USE_ASM_SHAPELOADER_DATA
.zero
; extern signed char          *scnData;
_scnData .dsb 2


.text

; unsigned char scnReadPointer;
_scnReadPointer .dsb 1

; extern signed char scnNewShapeX, scnNewShapeY, scnNewShapeZ;
_scnNewShapeX .dsb 1
_scnNewShapeY .dsb 1
_scnNewShapeZ .dsb 1

; extern signed char scnNewPointX, scnNewPointY, scnNewPointZ;
_scnNewPointX .dsb 1
_scnNewPointY .dsb 1
_scnNewPointZ .dsb 1

; extern unsigned char scnNewPointIdxPt1, scnNewPointIdxPt2, scnNewPointIdxPt3;
_scnNewPointIdxPt1 .dsb 1
_scnNewPointIdxPt2 .dsb 1
_scnNewPointIdxPt3 .dsb 1

; signed char scnNewShapeOrientation;
_scnNewShapeOrientation .dsb 1

; extern char scnNewPointChar;
_scnNewPointChar .dsb 1
; extern unsigned char npt, nfa, nseg, npart;
_npt .dsb 1
_nfa .dsb 1
_nseg .dsb 1
_npart .dsb 1

; extern unsigned char scnTmp
_scnTmp .dsb 1
#endif // USE_ASM_SHAPELOADER_DATA


#ifdef  USE_ASM_SHAPELOADER

; void scnAddVertice (){
_scnAddVertice:
.(
    ldy _glNbVertices
    lda _scnNewPointX
    sta _glVerticesX,Y
    lda _scnNewPointY
    sta _glVerticesY,Y
    lda _scnNewPointZ
    sta _glVerticesZ,Y
    inc _glNbVertices

    rts
.)


    ; glFacesPt1[glNbFaces]  = scnNewPointIdxPt1;  // Index Point 1
    ; glFacesPt2[glNbFaces]  = scnNewPointIdxPt2;  // Index Point 2
    ; glFacesPt3[glNbFaces]  = scnNewPointIdxPt3;  // Index Point 3
    ; glFacesChar[glNbFaces] = scnNewPointChar;  // Character
    ; glNbFaces++;


; void scnAddFace () {
_scnAddFace:
.(
    ldy _glNbFaces
    lda _scnNewPointIdxPt1
    sta _glFacesPt1,Y
    lda _scnNewPointIdxPt2
    sta _glFacesPt2,Y
    lda _scnNewPointIdxPt3
    sta _glFacesPt3,Y
    lda _scnNewPointChar
    sta _glFacesChar,Y
    inc _glNbFaces
    rts
.)


; void scnAddSegment (){
_scnAddSegment:    
.(
    ; glSegmentsPt1[glNbSegments] = scnNewPointIdxPt1;  // Index Point 1
    ; glSegmentsPt2[glNbSegments] = scnNewPointIdxPt2;  // Index Point 2
    ; glSegmentsChar[glNbSegments] = scnNewPointChar; // Character
    ; glNbSegments++;
    ldy _glNbSegments
    lda _scnNewPointIdxPt1
    sta _glSegmentsPt1,Y
    lda _scnNewPointIdxPt2
    sta _glSegmentsPt2,Y
    lda _scnNewPointChar
    sta _glSegmentsChar,Y
    inc _glNbSegments

    rts
.)


; void scnAddParticule (){
_scnAddParticule:
.(
    ; glParticlesPt[glNbParticles] = scnNewPointIdxPt1;  // Index Point
    ; glParticlesChar[glNbParticles] = scnNewPointChar; // Character
    ; glNbParticles++;        
    ldy _glNbParticles
    lda _scnNewPointIdxPt1
    sta _glParticlesPt,Y
    lda _scnNewPointChar
    sta _glParticlesChar,Y
    inc _glNbParticles
    rts
.)
#endif //  USE_ASM_SHAPELOADER


#ifdef USE_ASM_SHAPELOADER
_scnLoadShape:
.(

    ;; pha:txa:pha:tya:pha ;


    ; scnReadPointer = 0;
    ; npt = scnData[scnReadPointer++];
    ; nfa = scnData[scnReadPointer++];
    ; nseg = scnData[scnReadPointer++];
    ; npart = scnData[scnReadPointer++];
    ; scnTmp = glNbVertices + npt;


    lda #0;
    sta _scnReadPointer;
    tay;
    lda (_scnData),Y;
    iny;
    sta _npt;
    lda (_scnData),Y;
    iny;
    sta _nfa;
    lda (_scnData),Y;
    iny;
    sta _nseg;
    lda (_scnData),Y;
    iny;
    sta _npart;
    lda _glNbVertices;
    clc;
    adc _npt;
    sta _scnTmp;
    sty _scnReadPointer;


    ; do {
    ;     if (scnNewShapeOrientation == 0) {
    ;         scnNewPointX = scnNewShapeX + sizeX * scnData[scnReadPointer++];
    ;         scnNewPointY = scnNewShapeY + sizeY * scnData[scnReadPointer++];
    ;     } else {
    ;         scnNewPointY = scnNewShapeX + sizeY * scnData[scnReadPointer++];
    ;         scnNewPointX = scnNewShapeY + sizeX * scnData[scnReadPointer++];
    ;     }
    ;     scnNewPointZ = scnNewShapeZ + sizeZ * scnData[scnReadPointer++];
    ;     scnAddVertice ();
    ;     scnReadPointer++; // skip unused byte
    ; } while (glNbVertices != scnTmp); 



VerticesLoadLoop:

    lda _scnNewShapeOrientation;
    bne OrientationNotNull;

        ldy _scnReadPointer;
        lda (_scnData),Y;
        clc;
        adc _scnNewShapeX;
        sta _scnNewPointX;
        iny;
        sty _scnReadPointer;

        lda (_scnData),Y;
        clc;
        adc _scnNewShapeY;
        sta _scnNewPointY;
        iny;
        sty _scnReadPointer;
        ;;    sta scnNewPointX;
    ;;     sta scnNewPointX;
    jmp endOrientationSpecific;
            
OrientationNotNull:
            
        ldy _scnReadPointer;
        lda (_scnData),Y;
        clc;
        adc _scnNewShapeX;
        sta _scnNewPointX;
        iny;
        sty _scnReadPointer;

        lda (_scnData),Y;
        clc;
        adc _scnNewShapeY;
        sta _scnNewPointY;
        iny;
        sty _scnReadPointer;

endOrientationSpecific;

        ldy _scnReadPointer;
        lda (_scnData),Y;
        clc;
        adc _scnNewShapeZ;
        sta _scnNewPointZ;
        iny;
        iny; ;; skip unused byte
        sty _scnReadPointer;

        jsr _scnAddVertice;

    lda _glNbVertices;
    cmp _scnTmp;
    bne VerticesLoadLoop;


    ; scnTmp = glNbVertices - npt;
    lda _glNbVertices;
    sec;
    sbc _npt;
    sta _scnTmp;



    ; for (ii = 0; ii < nfa; ii++){
    ;     scnNewPointIdxPt1 = scnTmp+scnData[scnReadPointer++];  // Index Point 1
    ;     scnNewPointIdxPt2 = scnTmp+scnData[scnReadPointer++];  // Index Point 2
    ;     scnNewPointIdxPt3 = scnTmp+scnData[scnReadPointer++];  // Index Point 3
    ;     scnNewPointChar   = scnData[scnReadPointer++];  // Character
    ;     scnAddFace ();
    ; }


    ldx _nfa;
    beq FaceLoadDone;

FaceLoadLoop;

        ldy _scnReadPointer;

        lda (_scnData),Y;
        clc;
        adc _scnTmp;
        sta _scnNewPointIdxPt1;
        iny;

        lda (_scnData),Y;
        clc;
        adc _scnTmp;
        sta _scnNewPointIdxPt2;
        iny;

        lda (_scnData),Y;
        clc;
        adc _scnTmp;
        sta _scnNewPointIdxPt3;
        iny;

        lda (_scnData),Y;
        sta _scnNewPointChar;
        iny;

        sty _scnReadPointer;

        jsr _scnAddFace;

    dex;
    bne FaceLoadLoop;
FaceLoadDone;



    ; for (ii = 0; ii < nseg; ii++){
    ;     scnNewPointIdxPt1 = scnTmp+scnData[scnReadPointer++];  // Index Point 1
    ;     scnNewPointIdxPt2 = scnTmp+scnData[scnReadPointer++];  // Index Point 2
    ;     scnNewPointChar   = scnData[scnReadPointer++]; // Character
    ;     scnAddSegment ();
    ;     scnReadPointer++; // skip unused byte
    ; }

    ldx _nseg;
    beq SegmentLoadDone;
SegmentLoadLoop;
    
        ldy _scnReadPointer;
        
        lda (_scnData),Y;
        clc;
        adc _scnTmp;
        sta _scnNewPointIdxPt1;
        iny;

        lda (_scnData),Y;
        clc;
        adc _scnTmp;
        sta _scnNewPointIdxPt2;
        iny;

        lda (_scnData),Y;
        sta _scnNewPointChar;
        iny;
        iny; ;; skip unused byte

        sty _scnReadPointer;

        jsr _scnAddSegment;

    dex;
    bne SegmentLoadLoop;
SegmentLoadDone;


    ; for (ii = 0; ii < npart; ii++){
    ;     scnNewPointIdxPt1 = scnTmp+scnData[scnReadPointer++];  // Index Point
    ;     scnNewPointChar   = scnData[scnReadPointer++]; // Character
    ;     scnAddParticule ();        
    ; }

    ldx _npart;
    beq ParticuleLoadDone;
ParticuleLoadLoop;    
        ldy _scnReadPointer;
        
        lda (_scnData),Y;
        clc;
        adc _scnTmp;
        sta _scnNewPointIdxPt1;
        iny;

        lda (_scnData),Y;
        sta _scnNewPointChar;
        iny;

        sty _scnReadPointer;

        jsr _scnAddParticule;
    dex;
    bne ParticuleLoadLoop;
ParticuleLoadDone;


    ;; pla:tay:pla:tax:pla ;
    rts
.)
#endif // USE_ASM_SHAPELOADER
