#define TEXTURE_RED        33
#define TEXTURE_GREEN      34
#define TEXTURE_BLUE       123
#define TEXTURE_YELLOW     37
#define TEXTURE_CYAN       38
#define TEXTURE_MAGENTA    39
#define TEXTURE_GREENLIGHT 102


#define TEXTURE_WALL_TOP_0 41
#define TEXTURE_WALL_TOP_1 42
#define TEXTURE_WALL_TOP_2 43
#define TEXTURE_WALL_TOP_3 44
#define TEXTURE_WALL_TOP_4 46
#define TEXTURE_WALL_TOP_5 126
#define TEXTURE_WALL_TOP_6 58
#define TEXTURE_WALL_TOP_7 59

static char texture_wall_top[] = {
    TEXTURE_WALL_TOP_0,
    TEXTURE_WALL_TOP_1,
    TEXTURE_WALL_TOP_2,
    TEXTURE_WALL_TOP_3,
    TEXTURE_WALL_TOP_4,
    TEXTURE_WALL_TOP_5,
    TEXTURE_WALL_TOP_6,
    TEXTURE_WALL_TOP_7
};

#define TEXTURE_WALL_BOT_0 61
#define TEXTURE_WALL_BOT_1 62
#define TEXTURE_WALL_BOT_2 63
#define TEXTURE_WALL_BOT_3 64
#define TEXTURE_WALL_BOT_4 91
#define TEXTURE_WALL_BOT_5 92
#define TEXTURE_WALL_BOT_6 93
#define TEXTURE_WALL_BOT_7 94

static char texture_wall_bottom[] = {
    TEXTURE_WALL_BOT_0,
    TEXTURE_WALL_BOT_1,
    TEXTURE_WALL_BOT_2,
    TEXTURE_WALL_BOT_3,
    TEXTURE_WALL_BOT_4,
    TEXTURE_WALL_BOT_5,
    TEXTURE_WALL_BOT_6,
    TEXTURE_WALL_BOT_7
};

#define TEXTURE_JOINT_TOP_0 96
#define TEXTURE_JOINT_TOP_1 'b'
#define TEXTURE_JOINT_TOP_2 'c'
#define TEXTURE_JOINT_TOP_3 'e'
#define TEXTURE_JOINT_TOP_4 'g'
#define TEXTURE_JOINT_TOP_5 'h'
#define TEXTURE_JOINT_TOP_6 'j'
#define TEXTURE_JOINT_TOP_7 'l'

static char texture_joint_top[] = {
    TEXTURE_JOINT_TOP_0,
    TEXTURE_JOINT_TOP_1,
    TEXTURE_JOINT_TOP_2,
    TEXTURE_JOINT_TOP_3,
    TEXTURE_JOINT_TOP_4,
    TEXTURE_JOINT_TOP_5,
    TEXTURE_JOINT_TOP_6,
    TEXTURE_JOINT_TOP_7
};

#define TEXTURE_JOINT_BOT_0 'm'
#define TEXTURE_JOINT_BOT_1 'o'
#define TEXTURE_JOINT_BOT_2 'q'
#define TEXTURE_JOINT_BOT_3 'r'
#define TEXTURE_JOINT_BOT_4 't'
#define TEXTURE_JOINT_BOT_5 'v'
#define TEXTURE_JOINT_BOT_6 'w'
#define TEXTURE_JOINT_BOT_7 'y'

static char texture_joint_bottom[] = {
    TEXTURE_JOINT_BOT_0,
    TEXTURE_JOINT_BOT_1,
    TEXTURE_JOINT_BOT_2,
    TEXTURE_JOINT_BOT_3,
    TEXTURE_JOINT_BOT_4,
    TEXTURE_JOINT_BOT_5,
    TEXTURE_JOINT_BOT_6,
    TEXTURE_JOINT_BOT_7
};

